import random
# import sys

def main():
    rng = random.Random()

    # read start input
    line = input().split()
    width = int(line[0])
    height = int(line[1])
    players = int(line[2])

    map = [['.' for _ in range(height)] for _ in range(width)]
    start_pos = []

    # read map
    for y in range(height):
        line = input()
        for x in range(width):
            map[x][y] = line[x]
            if(map[x][y] == '='):
                start_pos.append((x, y))

    print(start_pos[0][0], start_pos[0][1])

    usedBomb = usedFreezer = False

    # loop rounds
    while True:
        line = input()
        game_still_running = int(line) == 1
        if not game_still_running:
            # exit when game is over
            break

        x, y, vx, vy, rem_bombs, rem_freezers = 0, 0, 0, 0, 0, 0

        for player in range(players):
            line = input().split()
            id, posx, posy, velox, veloy, bombs, freezers = line
            # you could do something with this information
            # my position
            if int(id) == 0:
                x, y, vx, vy, rem_bombs, rem_freezers = int(posx), int(posy), int(velox), int(veloy), int(bombs), int(freezers)

        line = input().split()
        bombs, freezers = int(line[0]), int(line[1])
        for _ in range(bombs):
            line = input().split()
            posx, posy, player_id = line
            # you could do something with this information
        for _ in range(freezers):
            line = input().split()
            posx, posy, player_id = line
            # you could do something with this information

        # use bombs/freezers
        if rem_bombs > 0 and rng.randint(1, 100) == 42:
            print("B", x, y)
        if rem_freezers > 0 and rng.randint(1, 100) == 42:
            print("F", x, y)

        # move (try 1000 times to find a random position without crashing
        for _ in range(1000):
            new_vx, new_vy = vx + rng.randint(-1, 1), vy + rng.randint(-1, 1)
            if not (0 <= (x+new_vx) < width and 0 <= (y+new_vy) < height):
                continue
            if map[x+new_vx][y+new_vy] != '#':
                break

        # print(x, y, vx, vy, new_vx, new_vy, file=sys.stderr) # you could print to stderr for debugging
        print("M", x+new_vx, y+new_vy)

if __name__ == "__main__":
    main()